#include "EtaMix.h"

EtaMix::EtaMix(){
	hnFwd = new TH1D("nFwd","nFwd",150, 0.,150.) ;
	hnBkw = new TH1D("nBkw","nBkw", 150, 0.,150. ) ;
	hnCtr = new TH1D ("nCtr","nCtr", 150, 0.,150. ) ;
	hnTotGood = new TH1D("nTotGood","nTotGood", 150, 0., 150.) ;
	henc = new TH2D("enc","enc",50,0.,50.,nbins, 0., nbins);
}


Double_t EtaMix::ComputeEventWeight() // compute eta of event
{
	int nFwd(0), nBkw(0), nCtr(0) ;
	for( unsigned int i=0 ; i< GoodTrackFourVector->size() ; i++ ) 
    {
		Double_t eta = GoodTrackFourVector->at(i).Eta() ;
		if( eta < -0.8 ) 
        { nBkw++ ;}
		else if( eta > 0.8 ) 
        { nFwd++ ;}
		else
        { nCtr++ ;}
    }
	
	hnFwd->Fill(nFwd);
	hnBkw->Fill(nBkw);
	hnCtr->Fill(nCtr);
	double nGood = GoodTrackFourVector->size() ;
	if( nGood > 149.5 ) nGood=149.5 ; 
	hnTotGood->Fill(nGood) ;
	
	Double_t ReturnValue = (100*Encode( nFwd ) + 10 * Encode( nCtr ) + Encode( nBkw )) ;
	return ReturnValue ;
}

Double_t EtaMix::Encode( int w )
{
	int Range[]={3,5,8,10,13,16,20,25,30,200} ;
	int i(0), j(0) ;
	while( w >= Range[i++] ) j++ ;
	henc->Fill(w, (Double_t) j) ;
	return (Long64_t) j ;
}

EtaMix::~EtaMix(){
hnFwd->Write();
hnBkw->Write();
hnCtr->Write();
hnTotGood->Write();
henc->Write();
}


// ======================================================================
// 
// ======================================================================
void EtaMix::multianalisis( const TLorentzVector &p1, const TLorentzVector &p2  , int &ChargeP1,int &ChargeP2, int SizeEv1 ,int SizeEv2 ,int evid){
defaultmultianalisis(p1,p2,ChargeP1,ChargeP2,SizeEv1 ,SizeEv2 ,evid);
}


