#include "EtaSegMix.h"



EtaSegMix::EtaSegMix(){
	hnTotGood = new TH1D("nTotGood","nTotGood", 150, 0., 150.) ;
	deltaeta = new TH1D("deltaeta","deltaeta", 200, -7, 7) ;
	deltaphi = new TH1D("deltaphi","deltaphi", 200, -7, 7) ;
	deltaNN = new TH1D("deltann","deltann", 100, -20, 20) ;
	double delta = (rangemax - rangemin)/(double)(maxnbins);
	etabinned= new TH1D("etabinnedpost","etabinnedpost",maxnbins,rangemin,rangemax);
	etabinnedp= new TH1D("etabinnedpre","etabinnedpre",maxnbins,rangemin,rangemax);
	for (int k =0; k< maxnbins; k++){
		rangehist.push_back(new TH1D(Form("range%3.1fto%3.1f",(rangemin+k*delta),(rangemin+(k+1)*delta)),Form("range%3.1fto%3.1f",(rangemin+k*delta),(rangemin+(k+1)*delta)), 100, 0, 20));
	}
}


Double_t EtaSegMix::ComputeEventWeight() // compute eta of event
{
	double delta = (rangemax - rangemin)/(double)(maxnbins);
	bool findin = false;
	vector<binsort> counterta;
	int counted=0;
	binsort a;
	a.weigth =0;
	for (int k =0; k< maxnbins; k++){
		a.binnumber = k;
		counterta.push_back(a);
	}
	for( unsigned int i=0 ; i< GoodTrackFourVector->size() ; i++ ) 
    {
		Double_t eta = GoodTrackFourVector->at(i).Eta() ;
		etabinnedp->Fill(eta);
		findin = false;
		for (int k =0; k< maxnbins; k++){
			if ( ((rangemin+k*delta) < eta) &&  (eta <=(rangemin+(k+1)*delta))){
				counterta[k].weigth++;
				counted++;
				
			}
		}
    }
	for (int k=0; k< maxnbins; k++){
	 		rangehist[k]->Fill((Double_t)counterta[k].weigth);
			etabinned->Fill((rangemin+(k+0.5)*delta),(Double_t)counterta[k].weigth);
			// etabinned->SetBinContent(k+1,(Double_t)counterta[k].weigth+etabinned->GetBinContent(k+1));
	}
	if ((GoodTrackFourVector->size()-counted)!=0) cout << "Warning, some trace not in range" << endl;
	hnTotGood->Fill(GoodTrackFourVector->size()) ;
	Double_t ReturnValue = pow(10,10)*GoodTrackFourVector->size()+Encode(counterta);
	return ReturnValue ;
}

Double_t EtaSegMix::Encode( vector<binsort> & caselle )
{
	Double_t coded = 0;
	sort(caselle.begin(),caselle.end());
	for (unsigned int mm=0; mm<caselle.size(); mm++) {
		coded += caselle[mm].binnumber*pow(10,maxnbins - mm);
	}
	return coded;
}

EtaSegMix::~EtaSegMix(){
hnTotGood->Write();
	deltaeta->Write();
	deltaphi->Write();
	for (int k =0; k< maxnbins; k++){
		rangehist[k]->Write();
		delete rangehist[k];
	}
	deltaNN->Write();
	etabinned->Write();
	etabinnedp->Write();
	delete deltaNN;
	delete deltaeta;
	delete deltaphi;
	delete hnTotGood;
	delete etabinnedp;
	delete etabinned;
}


// ======================================================================
// 
// ======================================================================
void EtaSegMix::multianalisis( const TLorentzVector &p1, const TLorentzVector &p2  , int &ChargeP1,int &ChargeP2, int SizeEv1 ,int SizeEv2 ,int evid){
defaultmultianalisis(p1,p2,ChargeP1,ChargeP2,SizeEv1 ,SizeEv2 ,evid);
	deltaeta->Fill(p1.Eta()-p2.Eta());
	deltaphi->Fill(p1.Phi()-p2.Phi());
	deltaNN->Fill(SizeEv1-SizeEv2);
}


