#include "EventMixer.h"

using namespace std;

EventMixer::EventMixer() 
{
	signalcalc = true;
	mixcalc = true;
	combination =0;
	
	
	
	// Preparazione dei grafici per il riferimento e il segnale
	
	// Segnale
	hqschnc = new TH1D("hqschnc","hqschnc",500,0.,5.); // Senza le correzione di Coulomb (per mc)
	hqsch = new TH1D("hqsch","hqsch",500,0.,5.); // Con le correzione di Coulomb
	
	
	 // solo per combinazione all'interno dello stesso evento

	hqosch = new TH1D("hqosch","hqosch",500,0.,5.);
	hqotsch = new TH1D("hqotsch","hqotsch",500,0.,5.);
	hqdchnc = new TH1D("hqdchnc","hqdchnc",500,0.,5.); // Senza le correzione di Coulomb (per mc)
	hqdch = new TH1D("hqdch","hqdch",500,0.,5.);
	hqodch = new TH1D("hqodch","hqodch",500,0.,5.);
	hqotdch = new TH1D("hqotdch","hqotdch",500,0.,5.);
	
	
	// Solo per il mixing
	
	hmix = new TH1D("hmix","hmix",500,0.,5.);
	hmixsc = new TH1D("hmixsc","hmixsc",500,0.,5.);
	hmixoc = new TH1D("hmixoc","hmixoc",500,0.,5.);
	
	// Grafici di controllo
	
	hChargeP = new TH1D("ChargeP","ChargeP",100,0.,2.);
	hEtaVsPtGoodP = new TH2D("EtaVsPtGoodP","EtaVsPtGoodP",100,0.,2.,60,-3.,3.);
	hPhiP = new TH1D("PhiP","PhiP",100,0.,TMath::Pi());
	hChargeM = new TH1D("ChargeM","ChargeM",-100,0.,100);
	hEtaVsPtGoodM = new TH2D("EtaVsPtGoodM","EtaVsPtGoodM",100,0.,2.,60,-3.,3.);
	hPhiM = new TH1D("PhiM","PhiM",100,0.,TMath::Pi());
	
	
	// Grafici di distribuzionie solo per il mixing
	
	hN1VsN2 = new TH2D("hn1vsn2","hn1vsn2",150,0.,150.,150,0.,150.);
	hN1MinusN2 = new TH1D("hN1MinusN2","hN1minusN2",150,-50,50.);
	hmixschVsN = new TH2D("hmixschVsN","hmixschVsN",200,0,2.,150,0,150.);
	hmixdchVsN = new TH2D("hmixdchVsN","hmixdchVsN",200,0,2.,150,0,150.);
	
	// hmixschVsPt = new TH2D("hmixschVsPt","hmixschVsPt",200,0,2.,100,0.,5.);
	// hmixdchVsPt = new TH2D("hmixdchVsPt","hmixdchVsPt",200,0,2.,100,0.,5.);
	
	// Grafici di distribuzione solo per le combinazioni all'interno dello stesso evento
	
	hqschncVsN = new TH2D("hqschncVsN","hqschncVsN",500,0.,5.,150,0.,150.);
	hqschVsN = new TH2D("hqschVsN","hqschVsN",500,0.,5.,150,0.,150.);
    hqoschVsN = new TH2D("hqoschVsN","hqoschVsN",500,0.,5.,150,0.,150.);
    hqotschVsN = new TH2D("hqotschVsN","hqotschVsN",500,0.,5.,150,0.,150.);
    hqdchncVsN = new TH2D("hqdchncVsN","hqdchncVsN",500,0.,5.,150,0.,150.);
    hqdchVsN = new TH2D("hqdchVsN","hqdchVsN",500,0.,5.,150,0.,150.);
    hqodchVsN = new TH2D("hqodchVsN","hqodchVsN",500,0.,5.,150,0.,150.);
    hqotdchVsN = new TH2D("hqotdchVsN","hqotdchVsN",500,0.,5.,150,0.,150.);
	
	
	// Grafici di distribuzione in pt solo per le combinazioni all'interno dello stesso evento
	
	// hqschncVsPt = new TH2D("hqschncVsPt","hqschncVsPt",500,0.,5.,100,0.,5.);
	// hqschVsPt = new TH2D("hqschVsPt","hqschVsPt",500,0.,5.,100,0.,5.);
    // hqoschVsPt = new TH2D("hqoschVsPt","hqoschVsPt",500,0.,5.,100,0.,5.);
    // hqotschVsPt = new TH2D("hqotschVsPt","hqotschVsPt",500,0.,5.,100,0.,5.);
    // hqdchncVsPt = new TH2D("hqdchncVsPt","hqdchncVsPt",500,0.,5.,100,0.,5.);
    // hqdchVsPt = new TH2D("hqdchVsPt","hqdchVsPt",500,0.,5.,100,0.,5.);
    // hqodchVsPt = new TH2D("hqodchVsPt","hqodchVsPt",500,0.,5.,100,0.,5.);
    // hqotdchVsPt = new TH2D("hqotdchVsPt","hqotdchVsPt",500,0.,5.,100,0.,5.);
	
  // GRAFICI 3D VS KT
	hqschncVsKtVsNch = new TH3D("hqschncVsKtVsNch","hqschncVsKtVsNch",200,0.,2.,100,0.,5.,150,0.,150.);
	hqschVsKtVsNch = new TH3D("hqschVsKtVsNch","hqschVsKtVsNch",200,0.,2.,100,0.,5.,150,0.,150.);
    hqoschVsKtVsNch = new TH3D("hqoschVsKtVsNch","hqoschVsKtVsNch",200,0.,2.,100,0.,5.,150,0.,150.);
    hqotschVsKtVsNch = new TH3D("hqotschVsKtVsNch","hqotschVsKtVsNch",200,0.,2.,100,0.,5.,150,0.,150.);
    hqdchncVsKtVsNch = new TH3D("hqdchncVsKtVsNch","hqdchncVsKtVsNch",200,0.,2.,100,0.,5.,150,0.,150.);
    hqdchVsKtVsNch = new TH3D("hqdchVsKtVsNch","hqdchVsKtVsNch",200,0.,2.,100,0.,5.,150,0.,150.);
    hqodchVsKtVsNch = new TH3D("hqodchVsKtVsNch","hqodchVsKtVsNch",200,0.,2.,100,0.,5.,150,0.,150.);
    hqotdchVsKtVsNch = new TH3D("hqotdchVsKtVsNch","hqotdchVsKtVsNch",200,0.,2.,100,0.,5.,150,0.,150.);
    hmixschVsKtVsNch = new TH3D("hmixschVsKtVsNch","hmixschVsKtVsNch",200,0.,2.,100,0.,5.,150,0.,150.);
    hmixdchVsKtVsNch = new TH3D("hmixdchVsKtVsNch","hmixdchVsKtVsNch",200,0.,2.,100,0.,5.,150,0.,150.);
  
  // MINI-JETS STUDIES
    hqschncVsPtSum = new TH2D("hqschncVsPtSum","hqschncVsPtSum",200,0.,2.,200,0.,10.);
    hqschVsPtSum = new TH2D("hqschVsPtSum","hqschVsPtSum",200,0.,2.,200,0.,10.);
    hmixschVsPtSum = new TH2D("hmixschVsPtSum","hmixschVsPtSum",200,0,2.,200,0.,10.);
    
    hschDphiDeta = new TH3D("hschDphiDeta","hschDphiDeta",50,-5,5.,50,-TMath::Pi()/2,TMath::Pi()*3/2,50,0.,5.);
    hdchDphiDeta = new TH3D("hdchDphiDeta","hdchDphiDeta",50,-5,5.,50,-TMath::Pi()/2,TMath::Pi()*3/2,50,0.,5.);    
    hmixschDphiDeta = new TH3D("hmixschDphiDeta","hmixschDphiDeta",50,-5,5.,50,-TMath::Pi()/2,TMath::Pi()*3/2,50,0.,5.);
    hmixdchDphiDeta = new TH3D("hmixdchDphiDeta","hmixdchDphiDeta",50,-5,5.,50,-TMath::Pi()/2,TMath::Pi()*3/2,50,0.,5.);

	
}

EventMixer::~EventMixer() 
{
	outgraph->cd();
	if (mixcalc){
		// Sum W2 per i grafici del Mixing
		hmix->Sumw2();
		hmixsc->Sumw2();
		hmixoc->Sumw2();
		
		hN1VsN2->Sumw2();
		hN1MinusN2->Sumw2();
		hmixschVsN->Sumw2();
		hmixdchVsN->Sumw2();
		
		
		// hmixschVsPt->Sumw2();
		// hmixdchVsPt->Sumw2();
		
		// Salvataggio grafici mixing
		hmix->Write();
		hmixsc->Write();
		hmixoc->Write();
		
		// Salvataggio grafici delle distribuzioni N
		hN1VsN2->Write();
		hN1MinusN2->Write();
		hmixschVsN->Write();
		hmixdchVsN->Write();
		
		// Pt
		// hmixschVsPt->Write();
		// hmixdchVsPt->Write();
    
    // 3D
    hmixschVsKtVsNch->Sumw2(); hmixdchVsKtVsNch->Sumw2();  
    hmixschVsKtVsNch->Write(); hmixdchVsKtVsNch->Write();
    
    //MINI-JETS STUDIES
    hmixschVsPtSum->Sumw2(); hmixschVsPtSum->Write();
    hmixschDphiDeta->Sumw2(); hmixschDphiDeta->Write();
    hmixdchDphiDeta->Sumw2(); hmixdchDphiDeta->Write();
		
		
	}
	if (signalcalc){
		// Sum W2 Grafici controllo
		hChargeP->Sumw2();
		hEtaVsPtGoodP->Sumw2();
		hPhiP->Sumw2();
		hChargeM->Sumw2();
		hEtaVsPtGoodM->Sumw2();
		hPhiM->Sumw2();
		
		// SumW2 grafici segnale
		
		hqschnc->Sumw2();
		hqsch->Sumw2();
		
		// Sumw2 grafici combinazioni all'interno dello stesso evento
		hqosch->Sumw2();
		hqotsch->Sumw2();
		hqdchnc->Sumw2();
		hqdch->Sumw2();
		hqodch->Sumw2();
		hqotdch->Sumw2();
		
		// Scrittura grafici di controllo
		
		hChargeP->Write();
		hEtaVsPtGoodP->Write();
		hPhiP->Write();
		hChargeM->Write();
		hEtaVsPtGoodM->Write();
		hPhiM->Write();
		
		hqschnc->Write();
		hqsch->Write();
		hqosch->Write();
		hqotsch->Write();
		hqdchnc->Write();
		hqdch->Write();
		hqodch->Write();
		hqotdch->Write();
		
		
		// Multiplicity
		hqschncVsN->Sumw2();
		hqschVsN->Sumw2();
		hqoschVsN->Sumw2();
		hqotschVsN->Sumw2();
		hqdchncVsN->Sumw2();
		hqdchVsN->Sumw2();
		hqodchVsN->Sumw2();
		hqotdchVsN->Sumw2();		
		
		hqschncVsN->Write();
		hqschVsN->Write();
		hqoschVsN->Write();
		hqotschVsN->Write();
		hqdchncVsN->Write();
		hqdchVsN->Write();
		hqodchVsN->Write();
		hqotdchVsN->Write();
		
		
		// Pt
		
		// hqschncVsPt->Sumw2();
		// hqschVsPt->Sumw2();
		// hqoschVsPt->Sumw2();
		// hqotschVsPt->Sumw2();
		// hqdchncVsPt->Sumw2();
		// hqdchVsPt->Sumw2();
		// hqodchVsPt->Sumw2();
		// hqotdchVsPt->Sumw2();

		// hqschncVsPt->Write();
		// hqschVsPt->Write();
		// hqoschVsPt->Write();
		// hqotschVsPt->Write();
		// hqdchncVsPt->Write();
		// hqdchVsPt->Write();
		// hqodchVsPt->Write();
		// hqotdchVsPt->Write();
    
    // 3D
	hqschncVsKtVsNch->Sumw2(); hqschVsKtVsNch->Sumw2(); hqoschVsKtVsNch->Sumw2(); hqotschVsKtVsNch->Sumw2();
  hqdchncVsKtVsNch->Sumw2(); hqdchVsKtVsNch->Sumw2(); hqodchVsKtVsNch->Sumw2(); hqotdchVsKtVsNch->Sumw2();  
	hqschncVsKtVsNch->Write(); hqschVsKtVsNch->Write(); hqoschVsKtVsNch->Write(); hqotschVsKtVsNch->Write();
  hqdchncVsKtVsNch->Write(); hqdchVsKtVsNch->Write(); hqodchVsKtVsNch->Write(); hqotdchVsKtVsNch->Write();
  
  //MINI-JETS STUDIES
  hqschncVsPtSum->Sumw2(); hqschncVsPtSum->Write(); hqschVsPtSum->Sumw2(); hqschVsPtSum->Write();
      hschDphiDeta->Sumw2(); hschDphiDeta->Write();
    hdchDphiDeta->Sumw2(); hdchDphiDeta->Write();
		
	}
	delete hmix;
	delete hmixsc;
	delete hmixoc;
	delete hChargeP;
	delete hEtaVsPtGoodP;
	delete hPhiP;
	delete hChargeM;
	delete hEtaVsPtGoodM;
	delete hPhiM;
	delete hqschnc;
	delete hqsch;
	delete hqosch;
	delete hqotsch;
	delete hqdchnc;
	delete hqdch;
	delete hqodch;
	delete hqotdch;
	
	delete hN1MinusN2;
	delete hN1VsN2;
	delete hmixschVsN;
	delete hmixdchVsN;
	
	delete hqschncVsN;
	delete hqschVsN;
	delete hqoschVsN;
	delete hqotschVsN;
	delete hqdchncVsN;
	delete hqdchVsN;
	delete hqodchVsN;
	delete hqotdchVsN;
  
  // delete hqschncVsPt; delete hqschVsPt; delete hqoschVsPt; delete hqotschVsPt; delete hqdchncVsPt; delete hqdchVsPt; delete hqodchVsPt; delete hqotdchVsPt;
  
  delete hqschncVsKtVsNch; delete hqschVsKtVsNch; delete hqoschVsKtVsNch; delete hqotschVsKtVsNch; delete hqdchncVsKtVsNch;
  delete hqdchVsKtVsNch; delete hqodchVsKtVsNch; delete hqotdchVsKtVsNch; delete hqschncVsPtSum; delete hqschVsPtSum;
  
  delete hmixdchVsKtVsNch; delete hmixschVsKtVsNch; delete hmixschVsPtSum;
  // delete hschDphiDeta; delete hdchDphiDeta; delete hmixschDphiDeta; delete hmixdchDphiDeta;

	
	outgraph->Close();
	delete outgraph;
	//outfilelist.close();
}
// =======================================================================
void EventMixer::EvtSort(int cycle)
{
	remapper a;
	int totalevents = 0;
	double selectedevents = 0;
	if (id_map.size() > 0) id_map.erase(id_map.begin(),id_map.end());
	for (int i=0; i<GetEntries(); i++) {
		GetEntry(i);
		totalevents +=GoodTrackFourVector->size();
		a.id = i;
		a.weigth = ComputeEventWeight();
		a.secweigth = ComputeEventSecWeight();
		a.trdweigth = ComputeEventTrdWeight();
		id_map.push_back(a);
		if (GoodTrackFourVector->size() > 0)
			selectedevents += ((GoodTrackFourVector->size()-1)*GoodTrackFourVector->size())/2.;
		if ((cycle!=0) && (i == cycle)) break;
	}
	sort(id_map.begin(),id_map.end());
	cout << " Events are sorted ! " << endl ;
	if (sortfileoutput.size() > 3){
		ofstream OutputSortedList(sortfileoutput.c_str(),ios::out) ;
		for( unsigned int i = 0 ; i< id_map.size() ; i++ ) 
		{
			char strg[100] ;
			sprintf(strg,"%d %d %f \n",i,id_map.at(i).id,id_map.at(i).weigth ) ;
			OutputSortedList << strg ;
		}
		OutputSortedList.close() ;
	}
	cout << "Total event: " << Form("%d",totalevents) << " selected events: " << Form("%f",selectedevents) << " map size: " << id_map.size() << endl;
	// return ListSorted ;
	
}
// =======================================================================
void EventMixer::analyze( int entry ) {
	return;
}
// =======================================================================
inline void EventMixer::SaveToFile( char* OutputFileName ) { outgraph = new TFile(OutputFileName,"recreate");outgraph->cd();}
// =======================================================================
inline void EventMixer::end_analysis() {}
// =======================================================================
inline void EventMixer::begin_analysis() { return ; }
// =======================================================================
void EventMixer::Loop( int evtmax, int ifirst) {
	// initialize timer
	TStopwatch Twatch ;
	Double_t TotalTime(0) ;
	// get number of events
	int evtnum = id_map.size();
	// last required event
	evtmax += ifirst;
	if ( evtmax > evtnum ) evtmax = evtnum;
	
	// user initialization
	begin_analysis() ;
	cout << " # ==> Start analysis. Process " << evtmax << " events  " << endl << endl ;
	// loop over all events
	vector<TLorentzVector> GoodTrackFourVectorEv1;
	vector<int> GoodTrackChargeEv1;
	vector<TLorentzVector> GoodTrackFourVectorEv2;
	vector<int> GoodTrackChargeEv2;
	int jentry;
	for ( jentry = ifirst; jentry+1 < evtmax; jentry+=2 ) {	
		GetIndexedEntry( jentry );
		GoodTrackFourVectorEv1 = *GoodTrackFourVector;
		GoodTrackChargeEv1 = *GoodTrackCharge;
		// outfilelist << EventId << flush;
		GetIndexedEntry(jentry+1);
		GoodTrackFourVectorEv2 = *GoodTrackFourVector;
		GoodTrackChargeEv2 = *GoodTrackCharge;
		// outfilelist  << " " << EventId << endl;
		if (signalcalc){ 
			SignalCalculator(GoodTrackFourVectorEv1,GoodTrackChargeEv1);
			SignalCalculator(GoodTrackFourVectorEv2,GoodTrackChargeEv2);
		}
		// combining group 1 w group 2
		if (mixcalc){
			hN1VsN2->Fill(GoodTrackFourVectorEv1.size(),GoodTrackFourVectorEv2.size());
			hN1MinusN2->Fill(GoodTrackFourVectorEv1.size()-GoodTrackFourVectorEv2.size());
			for (unsigned int ev1=0; ev1<GoodTrackFourVectorEv1.size();ev1++){
				// loop g1 w g2
				for (unsigned int ev2=0; ev2<GoodTrackFourVectorEv2.size();ev2++){
					if (splitcomb(GoodTrackFourVectorEv1[ev1],GoodTrackFourVectorEv2[ev2])) { continue; }
					multianalisis(GoodTrackFourVectorEv1[ev1],GoodTrackFourVectorEv2[ev2],GoodTrackChargeEv1[ev1],GoodTrackChargeEv2[ev2],GoodTrackChargeEv1.size(),GoodTrackChargeEv2.size(),jentry); // function for derivated class (do nothing by default)
				}
			}
			// outfilelist << endl;
		}
		//cout << jentry << endl;
		ProgressReport( jentry, TotalTime, Twatch ) ;
		if (stop_loop){
			break;
		}
	}
	if (((evtmax-ifirst)%2)!=0  && signalcalc) {
		cout << evtmax << " " << jentry << endl;
		cout << GetIndexedEntry(evtmax-1) << endl;
		GoodTrackFourVectorEv1 = *GoodTrackFourVector;
		GoodTrackChargeEv1 = *GoodTrackCharge;
		SignalCalculator(GoodTrackFourVectorEv1,GoodTrackChargeEv1);
	}
	cout << endl << " # ==> End analysis. Processed " << evtmax << " events  " << endl ;
	end_analysis() ;
	return;
}

// =======================================================================
// Compute correlated variable Q (= sqrt(qsq))
// =======================================================================

Double_t EventMixer::GetQ( const TLorentzVector &p1, const TLorentzVector &p2 ) {
	TLorentzVector Sum4V = p1+p2 ;
	Double_t q = Sum4V.Mag2() - 4*pimass*pimass  ;
	return (  q>0 ?  TMath::Sqrt(q) : -TMath::Sqrt(-q)  ) ; 
}

// =======================================================================
// return the wight factor due to Coloumb repulsion [Gamow] same charge
// =======================================================================

const Double_t EventMixer::CoulombW( const Double_t& q)  {
	const Double_t alpha=1./137.;
	Double_t x=2*TMath::Pi()*(alpha*pimass/q);
	return (TMath::Exp(x)-1.)/x;
}
// =======================================================================
// return the wight factor due to Coloumb attraction [Gamow] opposite charge
// =======================================================================

const  Double_t EventMixer::CoulombWpm( const Double_t& q) {
	const Double_t alpha=1./137.;
	Double_t x=2*TMath::Pi()*(alpha*pimass/q);
	return (1.-TMath::Exp(-x))/x;
}

// =======================================================================
// Invert Px,Py,Pz TLorentz Vector
// =======================================================================

const TLorentzVector EventMixer::InvertPVector( TLorentzVector &vec){
	TLorentzVector ovec = vec;
	ovec.SetPx(-vec.Px());
	ovec.SetPy(-vec.Py());
	ovec.SetPz(-vec.Pz());
	return ovec;
}

// =======================================================================
// Invert X,Y TLorentz Vector
// =======================================================================

const TLorentzVector EventMixer::InvertXYVector( TLorentzVector &vec){
	TLorentzVector ovec = vec;
	ovec.SetX(-vec.X());
	ovec.SetY(-vec.Y());
	return ovec;
}

// =======================================================================
//	Check split tracks
// =======================================================================

bool EventMixer::splitcomb(TLorentzVector &vec1,TLorentzVector &vec2){
	bool issplit=false;
	Double_t cosa = TMath::Abs(vec1.Px()*vec2.Px() + vec1.Py()*vec2.Py() + vec1.Pz()*vec2.Pz())/(vec1.P()*vec2.P());
	Double_t deltapt = TMath::Abs(vec1.Pt() - vec2.Pt());
	if ( (cosa >cos_cut) &&
		(deltapt < dpt_cut)) { issplit = true;}
	//cout << "cosa: " << cosa << " dpt: " << deltapt << " is split: " << issplit << endl;}
	return issplit; 
}
// ======================================================================
//	Calculate only for one vector
// ======================================================================

void EventMixer::SignalCalculator(vector<TLorentzVector> & GTVector,vector<int> &GTCharge){
	Double_t q,qo,qs;
	for (unsigned int ev1=0; ev1<GTVector.size();ev1++){
		// Fill control graphs
		if( GTCharge[ev1] > 0 ) {
			hChargeP->Fill(GTCharge[ev1]) ; 
			hEtaVsPtGoodP->Fill(GTVector[ev1].Pt(),GTVector[ev1].Eta()) ;
			hPhiP->Fill(GTVector[ev1].Phi()) ; 
		}
		else {
			hChargeM->Fill(GTCharge[ev1]) ;
			hEtaVsPtGoodM->Fill(GTVector[ev1].Pt(),GTVector[ev1].Eta()) ;
			hPhiM->Fill(GTVector[ev1].Phi()) ;
		}
		// loop g1 w g1
		for (unsigned int rev1=ev1+1; rev1<GTVector.size();rev1++){
			if (splitcomb(GTVector[ev1],GTVector[rev1])) { continue; }
			combination++;	
			q = GetQ(GTVector[ev1],GTVector[rev1]); // combining self
			qo=GetQ(GTVector[ev1],InvertPVector(GTVector[rev1])); // combining opposite p
			qs=GetQ(GTVector[ev1],InvertXYVector(GTVector[rev1])); // combining opposite xy
			singleanalisis(GTVector[ev1],GTVector[rev1],GTCharge[ev1],GTCharge[rev1]);// function for derivated class (do nothing by default)
			if (GTCharge[ev1] * GTCharge[rev1] > 0){
				hqschnc->Fill(q) ; // s c without coulomb
				hqsch->Fill(q,CoulombW(q)) ; // s c with coulomb
				hqosch->Fill(qo) ; // s c q opposite
				hqotsch->Fill(qs) ; // s c rotated
				
				// mult
				hqschncVsN->Fill(q,GTVector.size());
				hqschVsN->Fill(q,GTVector.size(),CoulombW(q));
				hqoschVsN->Fill(qo,GTVector.size());
				hqotschVsN->Fill(qs,GTVector.size());

				// pT
        TLorentzVector psum1 = GTVector[ev1] + GTVector[rev1];
				// hqschncVsPt->Fill(q,TMath::Abs(psum1.Pt())/2.);
        hqschncVsKtVsNch->Fill(TMath::Abs(psum1.Pt())/2.,GTVector.size(),q);
        hqschncVsPtSum->Fill(q,TMath::Abs(GTVector[ev1].Pt())+TMath::Abs(GTVector[rev1].Pt()));
				
        // hqschVsPt->Fill(q,TMath::Abs(psum1.Pt())/2.,CoulombW(q));
        hqschVsKtVsNch->Fill(TMath::Abs(psum1.Pt())/2.,GTVector.size(),q,CoulombW(q));
        hqschVsPtSum->Fill(q,TMath::Abs(GTVector[ev1].Pt())+TMath::Abs(GTVector[rev1].Pt()),CoulombW(q));
        
        hschDphiDeta->Fill( GTVector[ev1].Eta()-GTVector[rev1].Eta() , GTVector[ev1].Phi()-GTVector[rev1].Phi() , 
                            TMath::Abs(GTVector[ev1].Pt())+TMath::Abs(GTVector[rev1].Pt()) );
        
        psum1 = GTVector[ev1] + InvertPVector(GTVector[rev1]);
				// hqoschVsPt->Fill(qo,TMath::Abs(psum1.Pt())/2.);
        hqoschVsKtVsNch->Fill(TMath::Abs(psum1.Pt())/2.,GTVector.size(),qo);
        
        psum1 = GTVector[ev1] + InvertXYVector(GTVector[rev1]);
				// hqotschVsPt->Fill(qs,TMath::Abs(psum1.Pt())/2.);
        hqotschVsKtVsNch->Fill(TMath::Abs(psum1.Pt())/2.,GTVector.size(),qs);
        // hqschncVsPt->Fill(q,TMath::Abs(GTVector[ev1].Pt()-GTVector[rev1].Pt())/2.);
				// hqschVsPt->Fill(q,TMath::Abs(GTVector[ev1].Pt()-GTVector[rev1].Pt())/2.,CoulombW(q));
				// hqoschVsPt->Fill(qo,TMath::Abs(InvertPVector(GTVector[ev1]).Pt()-InvertPVector(GTVector[rev1]).Pt())/2.);
				// hqotschVsPt->Fill(qs,TMath::Abs(InvertXYVector(GTVector[ev1]).Pt()-InvertXYVector(GTVector[rev1]).Pt())/2.);
				
			}else{
				hqdchnc->Fill(q) ; // d c without coulomb
				hqdch->Fill(q,CoulombWpm(q)) ; // d c with coulomb
				hqodch->Fill(qo) ; // d c q opposite
				hqotdch->Fill(qs) ; // d c rotated
				
				// mult
				hqdchncVsN->Fill(q,GTVector.size());
				hqdchVsN->Fill(q,GTVector.size(),CoulombWpm(q));
				hqodchVsN->Fill(qo,GTVector.size());
				hqotdchVsN->Fill(qs,GTVector.size());
				
				// pT
        TLorentzVector psum1 = GTVector[ev1] + GTVector[rev1];
				// hqdchncVsPt->Fill(q,TMath::Abs(psum1.Pt())/2.);
        hqdchncVsKtVsNch->Fill(TMath::Abs(psum1.Pt())/2.,GTVector.size(),q);
				
        // hqdchVsPt->Fill(q,TMath::Abs(psum1.Pt())/2.,CoulombW(q));
        hqdchVsKtVsNch->Fill(TMath::Abs(psum1.Pt())/2.,GTVector.size(),q,CoulombW(q));
        
        psum1 = GTVector[ev1] + InvertPVector(GTVector[rev1]);
				// hqodchVsPt->Fill(qo,TMath::Abs(psum1.Pt())/2.);
        hqodchVsKtVsNch->Fill(TMath::Abs(psum1.Pt())/2.,GTVector.size(),qo);
        
        psum1 = GTVector[ev1] + InvertXYVector(GTVector[rev1]);
				// hqotdchVsPt->Fill(qs,TMath::Abs(psum1.Pt())/2.);
        hqotdchVsKtVsNch->Fill(TMath::Abs(psum1.Pt())/2.,GTVector.size(),qs);
        
        hdchDphiDeta->Fill( GTVector[ev1].Eta()-GTVector[rev1].Eta() , GTVector[ev1].Phi()-GTVector[rev1].Phi() , 
                            TMath::Abs(GTVector[ev1].Pt())+TMath::Abs(GTVector[rev1].Pt()) );
				// hqdchncVsPt->Fill(q,TMath::Abs(GTVector[ev1].Pt()-GTVector[rev1].Pt())/2.);
				// hqdchVsPt->Fill(q,TMath::Abs(GTVector[ev1].Pt()-GTVector[rev1].Pt())/2.,CoulombW(q));
				// hqodchVsPt->Fill(qo,TMath::Abs(InvertPVector(GTVector[ev1]).Pt()-InvertPVector(GTVector[rev1]).Pt())/2.);
				// hqotdchVsPt->Fill(qs,TMath::Abs(InvertXYVector(GTVector[ev1]).Pt()-InvertXYVector(GTVector[rev1]).Pt())/2.);
				
			}
		}
	}
}
// ============== disable signal calculation ============================
void EventMixer::DisableSignalCalculator(){
	signalcalc = false;
}

// ============== disable signal calculation ============================
void EventMixer::DisableMixCalculator(){
	mixcalc = false;
}
// ============== Enable signal calculation ============================
void EventMixer::EnableSignalCalculator(){
	signalcalc = true;
}

// ============== Enable signal calculation ============================
void EventMixer::EnableMixCalculator(){
	mixcalc = true;
}

// ======================================================================
// 
// ======================================================================
void EventMixer::defaultmultianalisis( const TLorentzVector &p1, const TLorentzVector &p2  , int &ChargeP1,int &ChargeP2, int SizeEv1 ,int SizeEv2 ,int evid){
	Double_t q=GetQ(p1,p2); // combining group 1 w group 2
	hmix->Fill(q) ;
  TLorentzVector psum2 = p1+p2;
	if (ChargeP1*ChargeP2 > 0){
		hmixsc->Fill(q) ;
		hmixschVsN->Fill(q,SizeEv1);
		// hmixschVsPt->Fill(q,TMath::Abs(psum2.Pt())/2.);
		// hmixschVsPt->Fill(q,TMath::Abs(p1.Pt()-p2.Pt())/2.); // OLD BY MATTIA
    hmixschVsKtVsNch->Fill(TMath::Abs(psum2.Pt())/2.,SizeEv1,q);
    hmixschVsPtSum->Fill(q,TMath::Abs(p1.Pt())+TMath::Abs(p2.Pt()));
    hmixschDphiDeta->Fill( p1.Eta()-p2.Eta() , p1.Phi()-p2.Phi() , TMath::Abs(p1.Pt())+TMath::Abs(p2.Pt()) );
		
	}else{
		hmixoc->Fill(q) ;
		hmixdchVsN->Fill(q,SizeEv1);
		// hmixdchVsPt->Fill(q,TMath::Abs(p1.Pt()-p2.Pt())/2.); // OLD BY MATTIA
		// hmixdchVsPt->Fill(q,TMath::Abs(psum2.Pt())/2.);
    hmixdchVsKtVsNch->Fill(TMath::Abs(psum2.Pt())/2.,SizeEv1,q);
    hmixdchDphiDeta->Fill( p1.Eta()-p2.Eta() , p1.Phi()-p2.Phi() , TMath::Abs(p1.Pt())+TMath::Abs(p2.Pt()) );
	}
}

