#include <TH1F.h>
#include <TFile.h>

int GraficiBec(){
	
	TFile *_file0 = new TFile("EventMixer.root");
	TH1F *snsc = gDirectory->Get("hqdch");
	TH1F *sns = gDirectory->Get("hqdchnc");
	TH1F *sc = gDirectory->Get("hqsch");
	TH1F *s = gDirectory->Get("hqschnc");
	TH1F *r = gDirectory->Get("hmixm");
	TH1F *qosc = gDirectory->Get("hqosch");
	TH1F *qooc = gDirectory->Get("hqodch");
	snsc->SetName("snsc");
	sns->SetName("sns");
	sc->SetName("sc");
	s->SetName("s");
	r->SetName("r");
	qosc->SetName("qosc");
	qooc->SetName("qooc");

	
	TH1F *sc_s = new TH1F(*sc);
	sc_s->Divide(s);
	sc_s->SetTitle("signal pesato / signal non pesato");
	sc_s->SetName("sc_s");

	TH1F *sc_r = new TH1F(*sc);
	sc_r->Divide(r);
	sc_r->SetTitle("signal pesato / reference");
	sc_r->SetName("sc_r");	
	
	TH1F *snsc_sns = new TH1F(*snsc);
	snsc_sns->Divide(sns);
	snsc_sns->SetTitle("n signal pesato / n signal non pesato");
	snsc_sns->SetName("snsc_sns");
	
	TH1F *sc_snsc = new TH1F(*sc);
	sc_snsc->Divide(snsc);
	sc_snsc->SetTitle("signal pesato/n signal pesato");
	sc_snsc->SetName("sc_snsc");
	
	TH1F *s_sns = new TH1F(*s);
	s_sns->Divide(sns);
	s_sns->SetTitle("signal/n signal");
	s_sns->SetName("s_sns");
	
	TH1F *sc_qosc = new TH1F(*sc);
	sc_qosc->Divide(qosc);
	sc_qosc->SetTitle("Signal pesato / qosc");
	sc_qosc->SetName("sc_qosc");
	
	TH1F *sc_qooc = new TH1F(*sc);
	sc_qooc->Divide(qooc);
	sc_qooc->SetTitle("Signal pesato / qooc");
	sc_qooc->SetName("sc_qooc");
	
	// Montecarlo
	
	TFile *_file1 = new TFile("EventMixermc.root");
	
	TH1F *smc =  gDirectory->Get("hqschnc");
	TH1F *snsmc = gDirectory->Get("hqdchnc");
	TH1F *qoscmc = gDirectory->Get("hqosch");
	TH1F *qoocmc = gDirectory->Get("hqodch");
	TH1F *rmc =  gDirectory->Get("hmixm");
	smc->SetName("smc");
	snsmc->SetName("snsmc");
	qoscmc->SetName("qoscmc");
	qoocmc->SetName("qoocmc");
	rmc->SetName("rmc");
	
	qoscmc->SetTitle("Qosc MC");
	qoocmc->SetTitle("Qooc MC");
	snsmc->SetTitle("Signalnotsame MC");
	smc->SetTitle("Signal MC");
	rmc->SetTitle("Reference MC");
	
	TH1F *smc_snsmc = new TH1F(* smc);
	smc_snsmc->Divide(snsmc);
	smc_snsmc->SetTitle("Signal MC/Signal not same MC");
	smc_snsmc->SetName("smc_snsmc");

	TH1F *smc_rmc = new TH1F(* smc);
	smc_rmc->Divide(rmc);
	smc_rmc->SetTitle("Signal MC/Reference MC");
	smc_rmc->SetName("smc_rmc");
	
	TH1F *smc_qoscmc = new TH1F(* smc);
	smc_qoscmc->Divide(qoscmc);
	smc_qoscmc->SetTitle("Signal MC/Qosc Mc");
	smc_qoscmc->SetName("smc_qoscmc");
	
	TH1F *smc_qoocmc = new TH1F(* smc);
	smc_qoocmc->Divide(qoocmc);
	smc_qoocmc->SetTitle("Signal MC/Qooc Mc");
	smc_qoocmc->SetName("smc_qoocmc");
	
	TH1F *doublerapps_sns = new TH1F(*sc_snsc);
	doublerapps_sns->SetTitle("Doppio rapporto Signal/Signal not same");
	doublerapps_sns->Divide(smc_snsmc);
	doublerapps_sns->SetName("doublerapps_sns");
	
	TH1F *doublerappsc_qosc = new TH1F(*sc_qosc);
	doublerappsc_qosc->Divide(smc_qoscmc);
	doublerappsc_qosc->SetTitle("Doppio rapporto Signal/Qosc");
	doublerappsc_qosc->SetName("doublerappsc_qosc");
	
	TH1F *doublerappsc_r = new TH1F(*sc_r);
	doublerappsc_r->Divide(smc_rmc);
	doublerappsc_r->SetTitle("Doppio rapporto Signal/Reference");
	doublerappsc_r->SetName("doublerappsc_r");

	TH1F *doublerappsc_qooc = new TH1F(*sc_qooc);
	doublerappsc_qooc->Divide(smc_qoocmc);
	doublerappsc_qooc->SetTitle("Doppio rapporto Signal/Qooc");
	doublerappsc_qooc->SetName("doublerappsc_qooc");
	
	
	TFile* f = new TFile("graficibec.root","RECREATE") ;
	snsc->Write();
	sns->Write();
	sc->Write();
	s->Write();
	sc_s->Write();
	snsc_sns->Write();
	sc_snsc->Write();
	s_sns->Write();
	smc->Write();
	snsmc->Write();
	smc_snsmc->Write();
	smc_qoocmc->Write();
	smc_qoscmc->Write();
	doublerapps_sns->Write();
	doublerappsc_qosc->Write();
	doublerappsc_qooc->Write();
	r->Write();
	sc_r->Write();
	smc_rmc->Write();
	doublerappsc_r->Write();
	sc_qosc->Write();
	sc_qooc->Write();
	
	f->Close();
}
