#ifndef MoltMix_h
#define MoltMix_h

#include "EventMixer.h"
#include <vector>
#include <TMatrixDSym.h>
#include <TMatrixDSymEigen.h> 


#ifndef BinSort_h
#define BinSort_h

struct binsort {
	Double_t weigth; // Peso
	int binnumber; // bin number
};


inline bool operator<(const binsort& primo,const binsort& secondo){
	return primo.weigth < secondo.weigth; // metodo per l'ordinamento
};

#endif

#ifndef matricontainer_h
#define matricontainer_h
struct matrixcontainer {
	Double_t weigth; // Peso
	TMatrixD thematrix; // autovettori
};



inline bool operator<(const matrixcontainer& primo,const matrixcontainer& secondo){
	return primo.weigth < secondo.weigth; // metodo per l'ordinamento
};
#endif

class MoltMix: public EventMixer {
	
public:
	MoltMix(); // Creatore della classe
	Double_t ComputeEventWeight(); // Calcolo del peso usato dell'event mixer
	~MoltMix();  // Distruttore
	void multianalisis( const TLorentzVector &p1, const TLorentzVector &p2  , int &ChargeP1,int &ChargeP2, int SizeEv1 ,int SizeEv2 ,int evid);
	

private:
	TH1D* hnFwd; // Grafici per vedere il comportamento di eta
	TH1D* hnBkw;
	TH1D* hnCtr;
	TH1D* hnTotGood;
	TH2D* henc;
	TH1D* deltaeta;
	TH1D* deltaphi;
	TH1D* deltaNN;
	TH1D* etabinnedp;
	TH1D* etabinned;
	vector<TH1D*> rangehist;
	static const int nbins = 10 ;
	static const int maxnbins = 10;
	static const double rangemin = -3.;
	static const double rangemax = 3.;
	
	
	vector<matrixcontainer> *matrixlist; // Indice per le matrici della classe
	TMatrixD GetMatrixFromId(int evid); // Metodo per avere la matrice associata a un evento
	TRotation *rotationmatrix; // Matrice di rotazione
	int lastid; // Variabile di supporto
	bool indexed; // Check sull'indicizzazione della classe
	
	
};

#endif
