#include "SphereMix.h"



SphereMix::SphereMix()
{
	// Inizializzazione dei grafici di distribuzione
	SphereVsN = new TH2D("SphereVsN","SphereVsN",200,0.,1.,100,0.,100.);
	Sphere = new TH1D("Sphere","Sphere",200,0.,1.);
}


// =======================================================================
Double_t SphereMix::ComputeEventWeight()
{
	
	Double_t SumP2 =0;
	Double_t SphT[]={0,0,0,0,0,0,0,0,0} ; // Inizializzazione del vettore iniziale per la matrice di sfericita'
	// Calcolo delle entrate della matrice di sfericita'
	for( unsigned int i=0 ; i< GoodTrackFourVector->size() ; i++ )
    {
		SphT[0] += GoodTrackFourVector->at(i).Px()*GoodTrackFourVector->at(i).Px() ;
		SphT[1] += GoodTrackFourVector->at(i).Px()*GoodTrackFourVector->at(i).Py() ;
		SphT[2] += GoodTrackFourVector->at(i).Px()*GoodTrackFourVector->at(i).Pz() ;
		
		SphT[3] += GoodTrackFourVector->at(i).Py()*GoodTrackFourVector->at(i).Px() ;
		SphT[4] += GoodTrackFourVector->at(i).Py()*GoodTrackFourVector->at(i).Py() ; 
		SphT[5] += GoodTrackFourVector->at(i).Py()*GoodTrackFourVector->at(i).Pz() ; 
		
		SphT[6] += GoodTrackFourVector->at(i).Pz()*GoodTrackFourVector->at(i).Px() ;
		SphT[7] += GoodTrackFourVector->at(i).Pz()*GoodTrackFourVector->at(i).Py() ; 
		SphT[8] += GoodTrackFourVector->at(i).Pz()*GoodTrackFourVector->at(i).Pz() ;
		
		SumP2 += GoodTrackFourVector->at(i).P() * GoodTrackFourVector->at(i).P() ;
    }
	
	if( SumP2 == 0 ) return -1 ; // Verifica del calcolo della sfericita'
	
	TMatrixDSym SphM( 3, SphT ) ; // Creazione della matrice
	
	SphM *= 1./SumP2; // Normalizzazione
	TMatrixDSymEigen SphE( SphM ) ; // Creazione della matrice di autovettori e autovalori
	TVectorD SphEigenValues = SphE.GetEigenValues() ;
	Double_t sph = 1.5 * (SphEigenValues[1]+SphEigenValues[2]);
	SphereVsN->Fill(sph,GoodTrackFourVector->size());
	Sphere->Fill(sph);
	return sph ; // Ritorno del peso
	
}

SphereMix::~SphereMix(){
	SphereVsN->Write();
	Sphere->Write();
	delete SphereVsN;
	delete Sphere;
}

// ======================================================================
// 
// ======================================================================
void SphereMix::multianalisis( const TLorentzVector &p1, const TLorentzVector &p2  , int &ChargeP1,int &ChargeP2, int SizeEv1 ,int SizeEv2 ,int evid){
	defaultmultianalisis(p1,p2,ChargeP1,ChargeP2,SizeEv1 ,SizeEv2 ,evid);
}
