#ifndef ZrotMix_h
#define ZrotMix_h

#include "EventMixer.h"
#include <TMatrixDSym.h>
#include <TMatrixDSymEigen.h> 

// Struttura che utilizzo per indicizzare le matrici
// Dato che il peso che si usa qui e nell'event mixer è lo stesso
// gli eventi saranno associat alle loro matrici di autovettori




#ifndef matricontainer_h
#define matricontainer_h

struct matrixcontainer {
	Double_t weigth; // Peso
	TMatrixD thematrix; // autovettori
};

inline bool operator<(const matrixcontainer& primo,const matrixcontainer& secondo){
	return primo.weigth < secondo.weigth; // metodo per l'ordinamento
};

#endif

class ZrotMix: public EventMixer {

public:
	ZrotMix();	 // Creatore
	~ZrotMix(); // Distruttore
	Double_t ComputeEventWeight(); // Funzione peso per event mixer
	void multianalisis( const TLorentzVector &p1, const TLorentzVector &p2  , int &ChargeP1,int &ChargeP2, int SizeEv1 ,int SizeEv2 ,int evid); // Funzione di analisi
	
private:
	vector<matrixcontainer> *matrixlist; // Indice per le matrici della classe
	TMatrixD GetMatrixFromId(int evid); // Metodo per avere la matrice associata a un evento
	Double_t GetWeightFromId(int evid); // Metodo per avere il peso a un evento
	TRotation *rotationmatrix; // Matrice di rotazione
	int lastid; // Variabile di supporto
	bool indexed; // Check sull'indicizzazione della classe
	
	TH1D* deltas;
	TH1D* deltaeta;
	TH1D* deltan;

};

#endif
