#include "TrackSelector.h"
#include "TChain.h"
#include <TBenchmark.h>
#include <signal.h>
#include <iostream>
#include <stdlib.h>

using namespace std;

// Define Global variable

TrackSelector d;


int info_action( int a, void(*b)(int) );
void handle_signal( int code );

int main(){
	info_action( SIGQUIT, handle_signal );
    info_action( SIGINT, handle_signal );
    info_action( SIGUSR1, handle_signal );
	TBenchmark *gBenchmark = new TBenchmark();
	TChain *track_chain = new TChain("PATtemplate/track_tree") ;
/*	
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_1.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_2.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_3.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_4.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_5.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_6.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_7.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_8.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_9.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_10.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_11.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_12.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_13.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_14.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_15.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_16.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_17.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_18.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_19.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_20.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_21.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_22.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_23.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_24.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_25.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_26.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_27.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_28.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_29.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_30.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_31.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_32.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_33.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_34.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_35.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_36.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_37.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_38.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_39.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_40.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_42.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_43.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_44.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_45.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_46.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_47.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_48.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_49.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_50.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_51.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_52.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_53.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_54.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_55.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_56.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_57.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_58.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_59.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_60.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_61.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_62.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_63.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_64.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_65.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_66.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_67.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_68.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_69.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_70.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_71.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_72.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_73.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_74.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_75.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_76.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_77.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_78.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_79.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_80.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_81.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_82.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_83.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_84.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_85.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_86.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_87.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_88.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_89.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_90.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_91.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_92.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_93.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_94.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_95.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_96.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_97.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_98.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_99.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_100.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_101.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_102.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_103.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_104.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_105.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_106.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_107.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_108.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_109.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_110.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_111.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_112.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_113.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_114.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_115.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_116.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_117.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_118.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_119.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_120.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_121.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_122.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_123.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_124.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_125.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_126.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_127.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_128.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_129.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_130.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_131.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_132.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_133.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_134.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_135.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_136.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_137.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_138.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_139.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_140.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_142.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_143.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_144.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_145.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_146.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_147.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_148.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_149.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_150.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_151.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_152.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_153.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_154.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_155.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_156.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_157.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_158.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_159.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_160.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_161.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_162.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_163.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_164.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_165.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_166.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_167.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_168.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_169.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_170.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_171.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_172.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_173.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_174.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_175.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_176.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_177.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_178.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_179.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_180.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_181.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_182.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_183.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_184.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_185.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_186.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_187.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_188.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_189.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_190.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_191.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_192.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_193.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_194.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_195.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_196.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_197.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_198.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_199.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_200.root/PATtemplate/track_tree");
	track_chain->Add("tuple-montecarlo/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_201.root/PATtemplate/track_tree");
*/	
TString base_path = "/raid5/data/MultiMuon/ntuple/MinBias_Summer09_STARTUP3X_V8K_900GeV_jetnocorr/";
        TString name_path1 = "/PhiAnalysis_MinimumBias_RECO_MC_STARTUP3X_V8K_jets_nocorr_";
        TString name_path2 = ".root/PATtemplate/track_tree";
        cout << Form("adding files: %s%sXXXXXX%s",base_path.Data(),name_path1.Data(),name_path2.Data()) << endl;
        for(int i = 1; i < 202; i++){
          track_chain->Add(Form("%s%s%d%s",base_path.Data(),name_path1.Data(),i,name_path2.Data()));
        }	

	//TProof *p = TProof::Open("");
	//track_chain.SetProof();
	d.InitOutput("testonemc.root");
	gBenchmark->Start("tcl");
	d.init( track_chain );
	d.Loop();
	d.SaveToFile( (char*)"TrackSelectormc.root" ) ;
	gBenchmark->Show("tcl");
}

int info_action( int a, void(*b)(int) )
{
    struct sigaction action;
	
    sigemptyset( &action.sa_mask );
    action.sa_flags = 0;
#ifdef SA_RESTART
    action.sa_flags |= SA_RESTART;
#endif
    if (b) {
		action.sa_handler = b;
    } else {
		action.sa_handler = SIG_IGN;
    }
    sigaction( a, &action, NULL );
	
    return 1;
}

void handle_signal( int code )
{
	if (code == SIGUSR1 || code ==SIGINT){
		cout << "Ctrl+c -> Closing" << endl;
		d.StopLoop();
	}
}
